#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <iostream>

using namespace std;

const int OVERHEAD_ITERATIONS = 100;

LONGLONG ComputeOverhead()
{
	LARGE_INTEGER liTime1, liTime2;
	LONGLONG llAverage = 0;
		
	for (int i=0; i < OVERHEAD_ITERATIONS; i++)
	{
		QueryPerformanceCounter(&liTime1);
		QueryPerformanceCounter(&liTime2);
		llAverage += liTime2.QuadPart - liTime1.QuadPart;
	}
	return llAverage / OVERHEAD_ITERATIONS;
}


int _tmain(int argc, char* argv[])
{
	LARGE_INTEGER liFrequency, liFirst, liLast;
	LONGLONG llOverhead;
	double dFrequency, dPeriod, dElapsed, dOverhead; 
	
	if (QueryPerformanceFrequency(&liFrequency) == 0)
	{
		fprintf(stderr, "Error timer not supported\n");
		return -1;
	}

	dFrequency = (double)(liFrequency.QuadPart) / 1e9; // Ticks por ns
	dPeriod = 1.0 / dFrequency;

	// Sobrecarga producida durante la toma de tiempos
	llOverhead = ComputeOverhead();
	dOverhead = llOverhead * dPeriod;

	printf("Frequency: %f Ticks/ns\n", dFrequency);
	printf("Period: %fns = Timer resolution\n", dPeriod);
	printf("Overhead: %fns = %I64d periods\n", dOverhead, llOverhead);

	// Se va a medir cunto tiempo tarda en imprimir un mensaje por pantalla
	// Utilizando printf
	QueryPerformanceCounter(&liFirst);
	printf("\nHello world\n\n");
	QueryPerformanceCounter(&liLast);
	dElapsed = (liLast.QuadPart - liFirst.QuadPart - llOverhead) * dPeriod;
	printf("Elapsed time using printf: %fus\n", dElapsed / 1000);

	// Utilizando cout
	QueryPerformanceCounter(&liFirst);
	cout << "\nHello world\n\n";
	QueryPerformanceCounter(&liLast);
	dElapsed = (liLast.QuadPart - liFirst.QuadPart - llOverhead) * dPeriod;
	printf("Elapsed time using cout: %fus\n", dElapsed / 1000);

	return 0;
}